package com.tzld.piaoquan.recommend.server.framework;


import com.tzld.piaoquan.recommend.server.framework.merger.MergeUtils;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueue;
import com.tzld.piaoquan.recommend.server.framework.recaller.BaseRecaller;
import com.tzld.piaoquan.recommend.server.framework.recaller.provider.RedisBackedQueueWithoutMeta;
import com.tzld.piaoquan.recommend.server.common.base.RankItem;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.userattention.UserAttentionExtractorPipeline;
import com.tzld.piaoquan.recommend.server.framework.userattention.UserAttentionExtractorUtils;
import com.tzld.piaoquan.recommend.server.framework.utils.RedisSmartClient;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;



public class VlogRecommendPipeline {

    public static final String FILTER_CONF = "filter_config.conf";
    public static final String MERGE_CONF = "merge_config.conf";

    public static final String PREFIX = "";


    private List<RankItem> feedByRec(final RecommendRequest requestData,
                                       final int requestIndex,
                                       final User userInfo) {
        int recallNum =  200;

        // Step 1: Attention extraction
        long timestamp = System.currentTimeMillis();
        UserAttentionExtractorPipeline attentionExtractorPipeline = UserAttentionExtractorUtils.getAtttentionPipeline(UserAttentionExtractorUtils.BASE_CONF);
        attentionExtractorPipeline.extractAttention(requestData, userInfo);

        // Step 2: create top queue
        StrategyQueue topQueue = MergeUtils.createTopQueue(MERGE_CONF, "top-queue");


        // Step 3: Candidate
        Map<String, Candidate> candidates = new HashMap<String, Candidate>();
        topQueue.candidate(candidates, recallNum, userInfo, requestData, 0, 0);

        // Step 4: Recalling & Basic Scoring
        RedisSmartClient client = new RedisSmartClient();
        RedisBackedQueueWithoutMeta queueProvider = new RedisBackedQueueWithoutMeta(client, 1000L);


        BaseRecaller recaller = new BaseRecaller(queueProvider);
        List<RankItem> items = recaller.recalling(requestData, userInfo, requestIndex, new ArrayList<Candidate>(candidates.values()));


        /*
        // Step 4: Advance Scoring
        timestamp = System.currentTimeMillis();
        ScorerPipeline scorerPipeline = getScorerPipeline(requestData);
        items = scorerPipeline.scoring(requestData, userInfo, requestIndex, items);


        // Step 5: Rerank
        timestamp = System.currentTimeMillis();
        RankPipeline rankPipeline = getRankPipeline(requestData;
        List<RankItem> resultItems = rankPipeline.doRank(requestData, userInfo, requestIndex, items);

        // Step 6: Global Rank & subList
        // TODO: Global Rank
        */


        return items;
    }


}
