package com.tzld.piaoquan.recommend.server.framework.utils;


import com.google.common.base.Charsets;
import com.tzld.piaoquan.recommend.server.framework.candidiate.QueueName;

/**
 * 正排倒排的key相关的utils
 */
public class IndexUtils {
    /**
     * 倒排索引专用的前缀, 用于区分同一个queue的多个存储版本, 读写要一致
     **/
    public static final String queuePrefixV1 = "a:";

    public static byte[] convertKey(String itemId) {
        return itemId.getBytes(Charsets.UTF_8);//BaseSafeEncoder.SAFE_CHARSET
    }

    /**
     * 用于转换倒排索引queue, 写入和读取的前缀要一致
     **/
    public static byte[] convertKey(QueueName queueName, String queuePrefix) throws Exception {
        return convertKey(queueName.toString(), queuePrefix);
    }

    /**
     * 用于转换倒排索引queue, 写入和读取的前缀要一致
     **/
    public static byte[] convertKey(String queueName, String queuePrefix) throws Exception {
        return convertKey(queuePrefix + queueName);
    }




}
