package com.tzld.piaoquan.recommend.server.implement.candidate;

import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.candidiate.IndexCandidateQueue;
import com.tzld.piaoquan.recommend.server.framework.candidiate.QueueName;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueConfig;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueInfo;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class SimpleHotCandidate extends IndexCandidateQueue {

    public static final String ItemType = "vlog";

    public SimpleHotCandidate(StrategyQueueInfo strategyQueueInfo, StrategyQueueConfig strategyQueueConfig) {
        super(strategyQueueInfo, strategyQueueConfig);
    }

    @Override
    public int addCandidateKey(Map<String, Candidate> candidates, int recallNum, User user, RecommendRequest requestData, int requestIndex, int expId) {
        int currRecall = 0;
        String region = user.getRegion();
        Map<String, Candidate> simplifiedCandidates = new ConcurrentHashMap<String, Candidate>();

        QueueName queueName24HRegion = new QueueName(ItemType, "rov")
                .addMatch("type", "region24h")
                .addMatch("region", region);
        currRecall += addCandidateKey(simplifiedCandidates, queueName24HRegion, 1, getStrategyQueueInfo().getQueueName());

        QueueName queueName1HRegion = new QueueName(ItemType, "rov")
                .addMatch("type", "region1h")
                .addMatch("region", region);

        currRecall += addCandidateKey(simplifiedCandidates, queueName1HRegion, 1, getStrategyQueueInfo().getQueueName());

        candidates.putAll(simplifiedCandidates);
        return currRecall;

    }
}