package com.tzld.piaoquan.recommend.server.implement.recaller;

import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.recaller.provider.InMemoryItem;
import com.google.common.collect.Sets;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.util.Set;


public class HistoryLongPeriodFilter extends AbstractFilter<InMemoryItem> {

    protected Set<String> historySet = Sets.newHashSet();

    public HistoryLongPeriodFilter(FilterConfigInfo filterConfigInfo,
                         RecommendRequest recommendRequest,
                         User user,
                         Integer requestIndex) {
        super(filterConfigInfo, recommendRequest, user, requestIndex);
        // 用户近1个月播放行为历史历史
        historySet = Sets.newHashSet(user.getLast1monthUserAction().getFeedsPlayed());
        if (historySet == null || historySet.size() == 0) {
            historySet = Sets.newHashSet();
        }
    }

    public boolean predicate(Candidate candidate, InMemoryItem t) {
        return !this.historySet.contains(t.id);
    }


}
